package org.dromara.work.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import lombok.RequiredArgsConstructor;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.work.domain.TpChangePrice;
import org.dromara.work.domain.bo.TpChangePriceBo;
import org.dromara.work.domain.vo.TpChangePriceVo;
import org.dromara.work.mapper.TpChangePriceMapper;
import org.dromara.work.service.ITpChangePriceService;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 改价配置Service业务层处理
 *
 * @author Maosw
 * @date 2024-08-12
 */
@RequiredArgsConstructor
@Service
public class TpChangePriceServiceImpl implements ITpChangePriceService {

    private final TpChangePriceMapper baseMapper;

    /**
     * 查询改价配置
     *
     * @param id 主键
     * @return 改价配置
     */
    @Override
    public TpChangePriceVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询改价配置列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 改价配置分页列表
     */
    @Override
    public TableDataInfo<TpChangePriceVo> queryPageList(TpChangePriceBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<TpChangePrice> lqw = buildQueryWrapper(bo);
        Page<TpChangePriceVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的改价配置列表
     *
     * @param bo 查询条件
     * @return 改价配置列表
     */
    @Override
    public List<TpChangePriceVo> queryList(TpChangePriceBo bo) {
        LambdaQueryWrapper<TpChangePrice> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<TpChangePrice> buildQueryWrapper(TpChangePriceBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<TpChangePrice> lqw = Wrappers.lambdaQuery();
        lqw.eq(StringUtils.isNotBlank(bo.getSid()), TpChangePrice::getSid, bo.getSid());
        lqw.eq(bo.getPrice() != null, TpChangePrice::getPrice, bo.getPrice());
        lqw.eq(bo.getState() != null, TpChangePrice::getState, bo.getState());
        lqw.eq(bo.getAddTime() != null, TpChangePrice::getAddTime, bo.getAddTime());
        return lqw;
    }

    /**
     * 新增改价配置
     *
     * @param bo 改价配置
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(TpChangePriceBo bo) {
        TpChangePrice add = MapstructUtils.convert(bo, TpChangePrice.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改改价配置
     *
     * @param bo 改价配置
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(TpChangePriceBo bo) {
        TpChangePrice update = MapstructUtils.convert(bo, TpChangePrice.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(TpChangePrice entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除改价配置信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
